#include "Uniforms.glsl"
#include "Samplers.glsl"
#include "Transform.glsl"
#include "ScreenPos.glsl"
#include "Lighting.glsl"

varying vec2 vTexCoord;
varying vec4 vColor;
uniform float cClipPos;

void VS()
{
    mat4 modelMatrix = iModelMatrix;
    vec3 worldPos = GetWorldPos(modelMatrix);
    gl_Position = GetClipPos(worldPos);
    
    vTexCoord = iTexCoord;
    vColor = iColor;
}

void PS()
{
    vec4 diffInput = texture2D(sDiffMap, vTexCoord);
	if (vTexCoord.x > cClipPos) {
		float intensity = GetIntensity(diffInput.rgb);
		gl_FragColor = vec4(intensity, intensity, intensity, 0.6) * cMatDiffColor;
	} else {
		gl_FragColor = diffInput * cMatDiffColor;
	}
}
